<?php

/**
 * DISCLAIMER
 *
 * Do not edit or add to this file
 *
 * @author    knowband.com <support@knowband.com>
 * @copyright 2017 Knowband
 * @license   see file: LICENSE.txt
 */
require_once 'GSBase.php';

class GSSingleAction extends GSBase
{

    protected $item_group_id = '';

    const PAGE_SIZE = 5000;

    protected $page_token = '';
    
    public function getProductList(&$products, $page_token = '', $return = false)
    {
        $parameters = array('maxResults' => 250); //250 Max allowed by google
        if (isset($page_token) && $page_token != '') {
            $parameters['pageToken'] = $page_token;
        }
        try {
            $response = $this->service->products->listProducts($this->merchant_id, $parameters);
            foreach ($response->getResources() as $product) {
                $products[] = $product;
            }
            if($response->nextPageToken != "") {
                $this->getProductList($products, $response->nextPageToken);
            }
        } catch (Google_IO_Exception $ex) {
            if($return == true) {
                throw new Exception($ex->getMessage());
            } else {
                echo $ex->getMessage();
            }
        } catch (Google_Auth_Exception $ex) {
            if($return == true) {
                throw new Exception($ex->getMessage());
            } else {
                echo $ex->getMessage();
            }
        } catch (Google_Service_Exception $ex) {
            if($return == true) {
                throw new Exception($ex->getMessage());
            } else {
                echo $ex->getMessage();
            }
        } catch (Google_Exception $ex) {
            if($return == true) {
                throw new Exception($ex->getMessage());
            } else {
                echo $ex->getMessage();
            }
        } catch (Exception $ex) {
            if($return == true) {
                throw new Exception($ex->getMessage());
            } else {
                echo $ex->getMessage();
            }
        }
    }
}
